var RIC = RIC || {};
!function($) {
    var self;
    var popup = function() {
        this.allMsPlatforms = {};
        this.isLoginMs = false;
        this.isLoginEarth = false;
        this.urls = {
            getAuthUrl: '/open/niu/get_auth_url',
            getAllMsPlatforms: '/open/common/get_all_ms_platforms',
            getMoveLogoMap: '/open/common/get_move_logo_map',
            checkLoginUrl: '/open/niu/check_login',
            getAlifanyiUserInfo: 'https://www.alifanyi.com/api/user_info',
        };
        self = this;
    };

    popup.prototype = {
        init: function() {
            self.renderMoveSourceGroup();
            self.getAllMsPlatforms(function () {
                Promise.all(self.getAuthUrl()).then(self.renderLoginShopGroup, self.handleError);
                Promise.all(self.checkLogin()).then(self.checkAliTranslateLogin, self.handleError).then(self.buildEmptyLoginShopBox, self.handleError);
            });

            $('.J_toggleViewOrLoginShopBtn').on('click', self.toggleViewOrLoginShop);
            $('.J_showMoveSourceBtn').on('click', self.showMoveSource);
        },
        getAllMsPlatforms: function(callback) {
            RICPlugin.ajax({
                'url': self.urls.getAllMsPlatforms,
                'type': 'get',
                'success': function (ret) {
                    if (ret['result'] === 'success') {
                        self.allMsPlatforms = ret['platforms'];
                        typeof callback === 'function' && callback();
                    } else {
                        layer.alert('加载失败，请重试或联系客服');
                        console.log(JSON.stringify(ret));
                    }
                },
                'error': function (ret) {
                    console.log(ret);
                }
            });
        },
        showMoveSource: function() {
            $('#J_viewShopPanel').hide();
            $('#J_loginShopPanel').hide();
            $('.J_toggleViewOrLoginShopBtn').val('login');
            $('.J_toggleViewOrLoginShopBtn').html('<i class="glyphicon glyphicon-eye-open"></i>查看登录店铺');
            $('#J_moveSourcePanel').show();
        },
        toggleViewOrLoginShop: function() {
            $('#J_moveSourcePanel').hide();
            var val = $(this).val();
            if (val === 'view') {
                $(this).val('login');
                $('#J_viewShopPanel').hide();
                $('#J_loginShopPanel').show();
                $('.J_toggleViewOrLoginShopBtn').html('<i class="glyphicon glyphicon-eye-open"></i>查看登录店铺');
            } else {
                $(this).val('view');
                $('#J_viewShopPanel').show();
                $('#J_loginShopPanel').hide();
                $('.J_toggleViewOrLoginShopBtn').html('<img src="http://plw.szchengji-inc.com/app/views/static/img/web_logo_transparent.png" style="height: 16px;"> 登录妙手');
            }
        },
        renderMoveSourceGroup: function() {
            RICPlugin.ajax({
                'url': self.urls.getMoveLogoMap,
                'type': 'get',
                'success': function (ret) {
                    if (ret['result'] === 'success') {
                        var moveLogoMap = ret['moveLogoMap'];
                        var moveSourceItemsHtml = '';
                        $.each(moveLogoMap, function (plat, moveLogoInfo) {
                            moveSourceItemsHtml += '<div class="inline text-center" style="margin: 5px;width: 10%;"><a href="' + moveLogoInfo['url'] + '" target="_blank" title="' + moveLogoInfo['tooltip'] + '"><img src="' + moveLogoInfo['logoUrl'] + '" style="width: 100%;border-radius: 50%;"></a></div>';
                        });
                        $('#J_moveSourceGroup').html(moveSourceItemsHtml);
                    } else {
                        console.log(JSON.stringify(ret));
                    }
                },
                'error': function (ret) {
                    console.log(ret);
                }
            });
        },
        getAuthUrl: function() {
            var promiseList = [];
            $.each(self.allMsPlatforms, function (plat, platInfo) {
                var promise = new Promise(function (resolve, reject) {
                    RICPlugin.ajax({
                        'url': platInfo.host + self.urls.getAuthUrl,
                        'type': 'GET',
                        'success': function (ret) {
                            if (ret['result'] === 'success') {
                                self.allMsPlatforms[plat]['authUrl'] = ret['authUrl'];
                                self.allMsPlatforms[plat]['position'] = ret['position'];
                                console.log(plat + ' get authUrl success:', ret['authUrl']);
                            } else {
                                console.log(JSON.stringify(ret));
                            }
                            resolve();
                        },
                        'error': function (ret) {
                            console.log(ret);
                            resolve();
                        }
                    });
                });
                promiseList.push(promise);
            });
            return promiseList;
        },
        renderLoginShopGroup: function() {
            var loginShopItemsHtml = '';
            $.each(self.allMsPlatforms, function (plat, configInfo) {
                var authUrl = configInfo['authUrl'];
                var position = configInfo['position'];
                var loginShopItemHtml = '<li class="login-shop-item"><a href="' + authUrl + '" target="_blank"><img src="http://plw.szchengji-inc.com/app/views/static/img/platform/' + plat + '.png"></a></li>';
                if (position === 'head') {
                    loginShopItemsHtml = loginShopItemHtml + loginShopItemsHtml;
                } else {
                    loginShopItemsHtml += loginShopItemHtml;
                }
            });
            $('#J_loginShopGroup').html(loginShopItemsHtml);
        },
        checkLogin: function() {
            var promiseList = [];
            layer.load();
            $.each(self.allMsPlatforms, function (plat, platInfo) {
                var promise = new Promise(function (resolve, reject) {
                    $.ajax({
                        'url': platInfo.host + self.urls.checkLoginUrl,
                        'data': {isFull: 1},
                        'type': 'POST',
                        'success': function (ret) {
                            if (ret['result'] === 'success') {
                                var shopInfo = ret['shopInfo'];
                                var shopInfoItemHtml = ret['shopInfoHtml'];
                                var position = ret['position'];
                                if (!shopInfoItemHtml) {
                                    shopInfoItemHtml = self.getShopInfoItemHtml(shopInfo);
                                }
                                if (position === 'head') {
                                    $('#J_viewShopPanel').prepend($(shopInfoItemHtml));
                                } else {
                                    $('#J_viewShopPanel').append($(shopInfoItemHtml));
                                }
                                if (shopInfo) {
                                    if (plat === 'earth') {
                                        self.isLoginEarth = true;
                                    } else {
                                        self.isLoginMs = true;
                                    }
                                }
                                console.log(plat + ' check success:', shopInfo);
                            } else {
                                console.log(JSON.stringify(ret));
                            }
                            resolve();
                        },
                        'error': function (ret) {
                            console.log(ret);
                            resolve();
                        }
                    });
                });
                promiseList.push(promise);
            });
            console.log(promiseList);
            return promiseList;
        },
        getShopInfoItemHtml: function(shopInfo) {
            if (!shopInfo) {
                return '';
            }
            var moveIndexUrl = shopInfo['moveIndexUrl'];
            var moveConfigUrl = shopInfo['moveShowConfigModalUrl'];
            var copyCountTip = '已用 ' + shopInfo['usedCount'] + ' / 共 ' + shopInfo['totalCount'];
            if (shopInfo['moveBillingType'] === 'time') {
                copyCountTip = '已用 ' + shopInfo['usedCount'] + ' / 每日 ' + shopInfo['totalCount'];
            }
            return '<div class="J_shopInfoItem" style="padding: 0 20px 0 20px;">'
                + '	    <div class="row" style="margin-top: 20px;">'
                + '		    <div class="col-xs-5 text-muted">应用店铺</div>'
                + '         <div class="col-xs-7"><div class="pull-right"><img src="' + shopInfo['logoUrl'] + '" style="width: 25px;height: 25px;border-radius: 50%;">&nbsp;' + shopInfo['shopName'] + '&nbsp;<a href="' + shopInfo['authUrl'] + '" target="_blank">切换</a></div></div>'
                + '     </div>'
                + '     <div class="row" style="margin-top: 10px;">'
                + '         <div class="col-xs-5 text-muted">复制额度</div>'
                + '         <div class="col-xs-7"><div class="pull-right">' + copyCountTip + '</div></div>'
                + '		</div>'
                + '		<div class="row" style="margin-top: 10px;">'
                + '			<div class="col-xs-5 text-muted">当前正在复制数量</div>'
                + '			<div class="col-xs-7"><div class="pull-right">' + shopInfo['processingCount'] + ' <a href="' + shopInfo['moveHistoryUrl'] + '" target="_blank">查看记录</a></div></div>'
                + '		</div>'
                + '		<div class="row" style="margin-top: 10px;">'
                + '			<div class="col-xs-12"><a href="' + moveIndexUrl + '" class="label label-info" target="_blank">进入妙手</a><a href="' + moveConfigUrl + '" class="label label-primary" target="_blank" style="margin-left: 5px;">搬家配置</a></div>'
                + '		</div>'
                + '     <hr style="margin-top:20px;border-top:1px silver dashed;"/>'
                + '</div>';
        },
        buildEmptyLoginShopBox: function() {
            layer.closeAll();
            if ($('.J_shopInfoItem').length) {
                return ;
            }
            var emptyLoginShopBoxHtml = ''
                + '<div style="padding: 20px 20px 0 20px;text-align: center;font-size: 20px;font-weight: bold;">'
                + ' <div class="jumbotron">当前无登录店铺</div>'
                + '</div>';
            $('#J_viewShopPanel').html(emptyLoginShopBoxHtml);
        },
        handleError: function(msg) {
            console.log(msg);
        },
        checkAliTranslateLogin: function() {
            return new Promise(function (resolve, reject) {
                if (!self.isLoginEarth) {
                    return resolve();
                }
                $('.J_loginAlifanyiBtn').removeClass('hidden');

                $.ajax({
                    'url': self.urls.getAlifanyiUserInfo,
                    'type': 'GET',
                    'headers': {
                        'accept': 'application/json, text/plain, */*',
                        'content-type': 'application/json;charset=UTF-8'
                    },
                    'success': function (resp) {
                        if (resp.code === 200) {
                            var userInfo = resp['data']['userDO'];
                            var aliTranslateHtml = self.getAliTranslateHtml(userInfo);
                            $('#J_viewAliTranslatePanel').append($(aliTranslateHtml));
                        }
                        resolve();
                    },
                    'error': function (ret) {
                        console.log(ret);
                        resolve();
                    }
                });
            });
        },
        getAliTranslateHtml: function(userInfo) {
            if (!userInfo) {
                return '';
            }
            return '<div class="J_shopInfoItem" style="padding: 0 20px 0 20px;">'
                + '	    <div class="row" style="margin-top: 20px;">'
                + '		    <div class="col-xs-5 text-muted">阿里翻译账号</div>'
                + '         <div class="col-xs-7"><div class="pull-right">&nbsp;' + userInfo['nickname'] + '&nbsp;&nbsp;<a href="https://www.alifanyi.com/login.html" target="_blank">切换</a></div></div>'
                + '     </div>'
                + '     <hr style="margin-top:20px;border-top:1px silver dashed;"/>'
                + '</div>';
        },
    };

    RIC.popup = new popup();
}(jQuery);

$(function() {
    RIC.popup.init();
});